MacDrawParser Class Referencefinal

the main class to read a MacDraw v0,v1 file More...

`#include <MacDrawParser.hxx>`

Inheritance diagram for MacDrawParser:

## Public Member Functions
| MacDrawParser (MWAWInputStreamPtr const &input, MWAWRSRCParserPtr const &rsrcParser, MWAWHeader *header)
| constructor
| ~MacDrawParser () final
| destructor
bool | checkHeader (MWAWHeader *header, bool strict=false) final
| checks if the document header is correct (or not)
void | parse (librevenge::RVNGDrawingInterface *documentInterface) final
| virtual function used to parse the input
Public Member Functions inherited from MWAWGraphicParser
| ~MWAWGraphicParser () override
| destructor
Public Member Functions inherited from MWAWParser
virtual | ~MWAWParser ()
| virtual destructor
int | version () const
| returns the works version
MWAWParserStatePtr | getParserState ()
| returns the parser state
MWAWHeader * | getHeader ()
| returns the header
MWAWInputStreamPtr & | getInput ()
| returns the actual input
MWAWListenerPtr | getMainListener ()
| returns the main listener
MWAWGraphicListenerPtr & | getGraphicListener ()
| returns the graphic listener
MWAWPresentationListenerPtr & | getPresentationListener ()
| returns the presentation listener
MWAWSpreadsheetListenerPtr & | getSpreadsheetListener ()
| returns the spreadsheet listener
MWAWTextListenerPtr & | getTextListener ()
| returns the text listener
MWAWFontConverterPtr & | getFontConverter ()
| returns the font converter
MWAWFontManagerPtr & | getFontManager ()
| returns the font manager
MWAWPageSpan const & | getPageSpan () const
| returns the actual page dimension
MWAWPageSpan & | getPageSpan ()
| returns the actual page dimension
double | getFormLength () const
| returns the form length
double | getFormWidth () const
| returns the form width
double | getPageLength () const
| returns the page length (form length without margin )
double | getPageWidth () const
| returns the page width (form width without margin )
MWAWRSRCParserPtr & | getRSRCParser ()
| returns the rsrc parser
libmwaw::DebugFile & | ascii ()
| a DebugFile used to write what we recognize when we parse the document

## Protected Member Functions
void | init ()
| inits all internal variables
void | createDocument (librevenge::RVNGDrawingInterface *documentInterface)
| creates the listener which will be associated to the document
bool | createZones ()
| finds the different objects zones
bool | readPrintInfo ()
| try to read the print info zone
bool | readPrefs ()
| try to the prefs zone ( mainly unknown )
int | readObject ()
| try to read an object.
bool | send (MacDrawParserInternal::Shape const &shape)
| try to send a shape
bool | sendBitmap (MacDrawParserInternal::Shape const &shape, MWAWPosition const &pos)
| try to send a bitmap to the listener
bool | sendText (int zoneId)
| try to send a text zone to the listener
Protected Member Functions inherited from MWAWGraphicParser
| MWAWGraphicParser (MWAWInputStreamPtr const &input, MWAWRSRCParserPtr const &rsrcParser, MWAWHeader *header)
| constructor (protected)
| MWAWGraphicParser (MWAWParserStatePtr const &state)
| constructor using a state
Protected Member Functions inherited from MWAWParser
| MWAWParser (MWAWParserState::Type type, MWAWInputStreamPtr const &input, MWAWRSRCParserPtr const &rsrcParser, MWAWHeader *header)
| constructor (protected)
| MWAWParser (MWAWParserStatePtr const &state)
| constructor using a state
void | setVersion (int vers)
| sets the document's version
void | setGraphicListener (MWAWGraphicListenerPtr &listener)
| sets the graphic listener
void | resetGraphicListener ()
| resets the listener
void | setPresentationListener (MWAWPresentationListenerPtr &listener)
| sets the presentation listener
void | resetPresentationListener ()
| resets the listener
void | setSpreadsheetListener (MWAWSpreadsheetListenerPtr &listener)
| sets the spreadsheet listener
void | resetSpreadsheetListener ()
| resets the listener
void | setTextListener (MWAWTextListenerPtr &listener)
| sets the text listener
void | resetTextListener ()
| resets the listener
void | setAsciiName (char const *name)
| Debugging: change the default ascii file.
std::string const & | asciiName () const
| return the ascii file name

## Protected Attributes
std::shared_ptr< MacDrawParserInternal::State > | m_state
| the state

## Friends
class | MacDrawParserInternal::SubDocument

## Detailed Description

the main class to read a MacDraw v0,v1 file

## Constructor & Destructor Documentation

## ◆ MacDrawParser()

MacDrawParser::MacDrawParser | ( | MWAWInputStreamPtr const & | input,
|  | MWAWRSRCParserPtr const & | rsrcParser,
|  | MWAWHeader * | header )

constructor

## ◆ ~MacDrawParser()

MacDrawParser::~MacDrawParser | ( |  | ) |
| final

destructor

## Member Function Documentation

## ◆ checkHeader()

bool MacDrawParser::checkHeader | ( | MWAWHeader * | header,
|  | bool | strict = false )
| final virtual

checks if the document header is correct (or not)

Implements MWAWParser.

Referenced by MacDrawParserInternal::SubDocument, and parse().

## ◆ createDocument()

void MacDrawParser::createDocument | ( | librevenge::RVNGDrawingInterface * | documentInterface | ) |
| protected

creates the listener which will be associated to the document

Referenced by MacDrawParserInternal::SubDocument, and parse().

## ◆ createZones()

bool MacDrawParser::createZones | ( |  | ) |
| protected

finds the different objects zones

Referenced by MacDrawParserInternal::SubDocument, and parse().

## ◆ init()

void MacDrawParser::init | ( |  | ) |
| protected

inits all internal variables

Referenced by MacDrawParser(), and MacDrawParserInternal::SubDocument.

## ◆ parse()

void MacDrawParser::parse | ( | librevenge::RVNGDrawingInterface * | documentInterface | ) |
| final virtual

virtual function used to parse the input

Implements MWAWGraphicParser.

Referenced by MacDrawParserInternal::SubDocument.

## ◆ readObject()

int MacDrawParser::readObject | ( |  | ) |
| protected

try to read an object.

Returns
  the object index or -1 if some error happens

Referenced by checkHeader(), createZones(), MacDrawParserInternal::SubDocument, and readObject().

## ◆ readPrefs()

bool MacDrawParser::readPrefs | ( |  | ) |
| protected

try to the prefs zone ( mainly unknown )

Referenced by createZones(), and MacDrawParserInternal::SubDocument.

## ◆ readPrintInfo()

bool MacDrawParser::readPrintInfo | ( |  | ) |
| protected

try to read the print info zone

Referenced by checkHeader(), MacDrawParserInternal::SubDocument, and readPrefs().

## ◆ send()

bool MacDrawParser::send | ( | MacDrawParserInternal::Shape const & | shape | ) |
| protected

try to send a shape

Referenced by MacDrawParserInternal::SubDocument, parse(), and send().

## ◆ sendBitmap()

bool MacDrawParser::sendBitmap | ( | MacDrawParserInternal::Shape const & | shape,
|  | MWAWPosition const & | pos )
| protected

try to send a bitmap to the listener

Referenced by MacDrawParserInternal::SubDocument, and send().

## ◆ sendText()

bool MacDrawParser::sendText | ( | int | zoneId | ) |
| protected

try to send a text zone to the listener

Referenced by MacDrawParserInternal::SubDocument.

## Friends And Related Symbol Documentation

## ◆ MacDrawParserInternal::SubDocument

friend class MacDrawParserInternal::SubDocument
| friend

## Member Data Documentation

## ◆ m_state

std::shared_ptr<MacDrawParserInternal::State> MacDrawParser::m_state
| protected

the state

Referenced by checkHeader(), createZones(), init(), MacDrawParser(), parse(), readObject(), send(), and sendText().

The documentation for this class was generated from the following files:

- MacDrawParser.hxx
- MacDrawParser.cxx